global {
	stend = false,
	gput= false,
	up = false,
	smazaka = false,
	smazaka1 = false,
	smazaka2 = false,
	stend= false,
	kot = false,
	legla = false,
	tum = false,
	gs = false,
};

morph:word({ neuter = true, 
		    singular = true, 
		    "варенье", 
		    "варенье", 
		    "варенью", 
		    "варенье", 
		    "вареньем", 
		    "варенье" })

Attribute [[~smeared]];

pol = obj {
	nam = _'пол';
	Exam = function(s)
		p [[Под тобой обычный пол.]]
	end;
	Walk = function(s)
		if here() == krovat then
			return krovat:WalkOut()
		end
		if up then
			return here():WalkOut()
		end
		p [[Но ты уже и так стоишь на полу!]]
	end;
	alias [[Walk: WalkIn, Climb ]];
}
mykrovat = obj {
	nam = _'кровать';
	Exam = function(s)
		if here() == krovat then
			p (here().dsc)
		else
			p [[Кровать тебя сейчас не интересует.]]
		end
	end;
	Default = [[Тебя ждет варенье!]];
	alias [[Walk: WalkIn, Climb ]];
}
krovat = room {
	nam = 'В кровати';
	dsc = [[Ты лежишь в своей постели... а между тем пора что-то делать.]];
	d_to = 'bedroom';
	walkout = _'кровать';
	WalkOut = function(s)
		walk(bedroom);
	end;
	exit = function(s)
		stend = true
		p [[Ты выбираешься из под одеяла и сползаешь с кровати на пол.]];
	end;
	obj = { 'pol', 'mykrovat' };
}


toys = obj {
	nam = _'игрушки';
	Default = [[Не время играть!]];
}

bedroom = room {
	nam = 'Спальня';
	walkout = _'спальня';
	dsc = [[Твоя спальня. Кровать, разбросанные игрушки и прочая детская утварь.^
	На востоке через приоткрытую дверь видна часть коридора, освещенного ночной лампой.]];
	e_to = 'koridor';
	exit = [[Мягко ступая босыми ножками ты выходишь в коридор.]];
	WalkOut = function(s)
		walk(koridor);
	end;
	obj = { 'pol', 'mykrovat', 'toys' };
	way = { vroom(_'коридор', 'koridor') };
}

pet10 = obj {
	nam = function(s)
		if up then
			p (_'~верхние петли|петли');
		else
			p (_'~верхние петли');
		end
	end;
	Exam = function(s, w)
		if not up then
			p [[Снизу тебе не видно.]];
			return
		end
		if not smazaka2 then
			p [[Дверные петли давно не смазывались. По крайней мере эта.]]
		else
			p [[Эта петля хорошо смазана отличным оливковым маслом.]]
		end;
	end;
	Smear = function(s)
		if not up then
			p [[Не дотянуться.]]
		else
			if smazaka2 then
				p [[Уже смазано. Папа говорит, что сильно хорошо - это тоже нехорошо.]]
				return
			end
			p [[Ты обильно полила верхний шарнир двери великолепным оливковым маслом. Теперь он точно не заскрипит!]]
			smazaka2 = true
		end
	end;
}

pet1 = obj {
	nam = function(s)
		if not up then
			p (_'~нижние петли|петли');
		else
			p (_'~нижние петли');
		end
	end;
	Exam = function(s, w)
		if up then
			p [[Сверху тебе не видно.]];
			return
		end
		if not smazaka1 then
			p [[Дверные петли давно не смазывались. По крайней мере эта.]]
		else
			p [[Эта петля хорошо смазана отличным оливковым маслом.]]
		end;
	end;
	Smear = function(s)
		if up then
			p [[Не дотянуться.]]
		else
			if smazaka1 then
				p [[Уже смазано. Папа говорит, что сильно хорошо - это тоже нехорошо.]]
				return
			end
			p [[Ты обильно полила нижний шарнир двери великолепным оливковым маслом. Теперь он точно не заскрипит!]]
			smazaka1 = true
		end
	end;
}

door1 = obj {
	nam = _'дверь';
	attr [[ door, openable, ~opened ]];
	Exam = function(s)
		if here() == bedroom_rod then
			p [[Дверь в коридор приоткрыта ровно настолько, чтобы туда могла незаметно проскользнуть маленькая, хитрая девочка.]]
			return
		end
		if s.opened then
			p [[Дверь в комнату родителей приоткрыта ровно настолько, чтобы туда могла незаметно проскользнуть маленькая, хитрая девочка.]]
		else
			p [[Родители обычно держат дверь в свою комнату закрытой, чтобы всякие маленькие девочки не подглядывали.]]
		end
	end;
	when_opened = [[Дверь уже открыта. Можешь в нее проскользнуть.]];
	when_closed = [[Ты стукнулась лбом в закрытую дверь. Слава Богу негромко.]];
	before_Close = function()
		if here() == bedroom_rod then
			p [[Если ты закроешь дверь, то в спальне станет совсем темно.]]
			return
		end
	end;
	before_Open = function()
		smazaka = smazaka1 and smazaka2
		if not smazaka then
			p [[Ты много раз на дню слышишь как ужасно скрипит эта дверь и как папа обещает маленько отдохнуть и смазать эти «долбаные петли».]]
			return
		end
	end;
	after_Open = function(s)
		if parser:react() then
			return
		end
		p [[Ты осторожно приоткрыла дверь в комнату родителей. Теперь ты можешь в нее войти.]];
	end;
	after_WalkIn = function(s)
		if s.opened then
--			p [[Ты тихонечко проскользнула в дверь.]];
		end
	end;
	door_to = function(s)
		if here() == koridor then
			return 'bedroom_rod';
		end
		return 'koridor'
	end;
	obj = { 'pet1', 'pet10' };
}

resh = obj {
	nam = _'решетка';
	Exam = function(s)
		p [[Конструкция представляет из себя деревянную решетку, прибитую к стене, к которой крепятся небольшие полки для горшков с цветами. Ты уже убедилась, что при желании этим можно воспользоваться как лестницей, побывать под потолком и потом получить по попе.]]
		if up then
			p [[Но сейчас тебя никто не видит и ты смело можешь болтаться под потолком всю ночь.]]
		end
	end;
	Climb = function(s)
		if up then
			p [[Ты и так под самым потолком!]];
		else
			p [[Ловко цепляясь за перекладины решетки ты карабкаешься к потолку, стараясь не задеть полки с цветами. Вот ты под потолком. Перед тобой верхний край двери в комнату родителей.]]
		end
		up = true
	end;
	WalkOut = function(s)
		if up then
			p [[Ты быстренько спустилась вниз.]]
		else
			p [[Ты стоишь на полу!]]
		end
		up = false
	end;
}
koridor = room {
	nam = 'Коридор';
	dsc = [[Длинный коридор ведет на юг к кухне. На востоке дверь в комнату родителей.^
		По обеим сторонам двери к стене прибита красивая резная решетка до потолка с полками, на которых стоят цветы. Мама долго упрашивала папу сделать эту «красоту», папа сказал много непонятных тебе слов, но потом все-таки сделал.]];
	s_to = 'kitchen';
	w_to = 'bedroom';
	e_to = 'bedroom_rod';
	d_to = function(s)
		if up then
			return resh:WalkOut();
		end
	end;
	before_Any = function(s, e)
		if up and (e:find("Open") or e:find("Close")) then
			p [[Сначала спустись вниз.]]
		end
	end;
	walkout = function(s)
		if up then
			return _'решетка';
		end
	end;
	WalkOut = function(s)
		return resh:WalkOut();
	end;
	exit = function(s, to)
		if up and to == s then
			resh:WalkOut()
			return false
		end
		if up then
			p [[Сначала спустись вниз.]]
			return false
		end
		if to == bedroom_rod and not door1.opened then
			p [[Перед тобой закрытая дверь.]]
			return false
		end
	end;
	left = function(s, to)
		if to == bedroom then
			p [[Ты возвращаешься в свою комнату.]]
			return
		end
		if to == bedroom_rod then
			p [[Ты проскальзываешь в комнату родителей.]]
			return
		end
		if to == kitchen then
			p [[Бесшумно ты крадешься на кухню.]]
			return
		end
	end;
	obj = { 'door1', 'resh', 'pol' };
	way = { vroom(_'спальня', 'bedroom'), vroom(_'кухня', 'kitchen'), vroom(_'комната родителей|~спальня родителей', 'bedroom_rod') };
}
varenye = obj {
	nam = _'варенье|~банка';
	Exam = function(s)
		servant:Exam()
	end;
	Open = [[Сначала нужно его взять!]];
	Take = function(s)
		if not up then
			p [[Тебе не дотянуться до верхнего шкафа, где спрятано варенье.]]
			return
		end
		if not servant.opened then
			p [[Ты не можешь взять варенье из закрытого шкафа.]]
			return
		end
		walkin 'happyend'
	end;
	Default = function(s)
		if not up then
			p [[Тебе не дотянуться до верхнего шкафа, где спрятано варенье.]]
			return
		end
		if not servant.opened then
			p [[Ты не можешь достать варенье из закрытого шкафа.]]
			return
		end
	end;
}
servant = obj {
	nam = _'сервант|~шкаф';
	attr [[openable, ~opened]];
	Exam = function(s)
		if not up then
			p [[Огромный сервант, в недрах которого храниться вожделенное лакомство возвышается к самому потолку. Для очень маленькой девочки это просто неприступная крепость, но для умной маленькой девочки это не сложнее, чем сходить на горшок.]]
			return
		end
		if s.opened then
			p [[Дверцы шкафа распахнуты и заветная банка варенья прямо перед тобой.]]
		else
			p [[Сквозь стеклянные дверцы шкафа ты видишь большую банку мали-малина-вана-нава-наваго-во варенья, но взять его не можешь, покуда дверцы заперты.]]
		end
	end;
	before_Open = function(s, w)
		if not up then
			p [[До шкафа тебе не дотянуться ближайшие лет 7-8.]]
			return
		end
		if not have 'kluch' then
			p [[Шкаф благоразумно заперт на ключ, которого у тебя нет.]]
			return
		end
		if w and w ~= kluch then
			p [[У тебя хорошее воображение!]]
			return
		end
		if s.opened then
			p [[Дверцы распахнуты настежь.]]
			return
		end
	end;
	before_Close = function(s)
		if s.opened then
			p [[Там же варенье!]]
			return
		end
	end;
	after_Open = function(s)
		p [[Ты открываешь  двверцы шкафа ключом - цель близка.]];
	end;
	obj = { 'varenye' };
}
stul = obj {
	nam = _'стул';
	Climb = function(s)
		if up then
			p [[Ты уже и так на стуле.]]
			return
		end
		if gput then
			p [[Ты вскарабкалась на стул - теперь ты можешь дотянуться до заветной дверцы.]]
			up = true
			return
		else
			p [[Ты залезла на стул - высоко-о-о!!! Но толку мало и  ты слезла обратно вниз.]]
		end
	end;
	WalkOut = function(s)
		if up then
			p [[Ты быстренько спустилась вниз.]]
		else
			p [[Ты стоишь на полу!]]
		end
		up = false
	end;
	Exam = function(s)
		p [[Большой деревянный стул. Высо-окий! Тяже-елый!]];
		if gput then
			p [[Стоит возле серванта.]]
		else
			p [[Стоит возле стола.]]
		end
	end;
	Take = [[Слишком тяжелый стул, чтобы его могла поднять такая маленькая девочка.]];
	Push = function(s)
		if up then
			p [[Ты не можешь двигать стул, стоя на нем.]];
			return
		end
		if gput then
			p [[Стул уже стоит там где надо.]];
			return
		end
		p [[Сопя и пыхтя ты двигаешь стул к серванту.]]
		gput = true
	end;
	alias [[Push: Pull]];
}
sosiska = obj {
	nam = _'сосиска';
	attr [[takeable]];
	Exam = [[Ты думаешь, что сосиска еще не успела испортиться.]];
	after_Take = [[Ты берешь из холодильника холодную сосику.]];
	Eat = [[Сосиска холодная и не варенная.]];
	before_Default = function(s)
		if up then
			p [[Слезь сначала со стула.]];
			return
		end
	end;
}:disable();

oil = obj {
	nam = _'~бутылка масла|масло';
	plural = false;
	attr [[takeable]];
	
	Exam = [[Оливковое масло хорошо для жарки, но и в качестве смазки.]];
	after_Take = [[Ты берешь бутылку масла.]];
	before_Default = function(s)
		if up then
			p [[Слезь сначала со стула.]];
			return
		end
	end;
}:disable();
icecap = obj {
	nam = _'холодильник';
	attr [[openable, ~opened, container]];
	Exam = function(s)
		p [[Большой холодильник для хранения скоропортящихся продуктов. Сейчас он]]
		if s.opened then
			p [[открыт.]]
		else
			p [[закрыт.]]
		end
		local r, n = parser:content(s, 'вн')
		if n > 0 then
			p ("Внутри холодильника ты нашла ", r)
		end
	end;
	before_Any = function(s, e)
		if up and (e:find("Open") or e:find("Close")) then
			p [[Ты не можешь сделать этого, стоя на стуле.]];
		end
	end;
	after_Open = function(s)
		if parser:react() then
			return
		end
		s:enable_all();
		p [[Ты открыла холодильник.]];
	end;
	Receive = function(s, w)
		if w == oil or w == sosiska then
			if not s.opened then
				p ([[Ты решила поставить ]], w:M 'вн', [[ в холодильник, но он был закрыт.]])
				return
			end
			if w == oil then
				p [[Ты поставила ]];
			else
				p [[Ты положила ]]
			end
			p (w:M 'вн', [[ обратно в холодильник.]])
			move(w, s, me())
		end
	end;
	Eat = [[Тебе не нравится вкус оливкового масла.]];
	after_Close = function(s)
		if parser:react() then
			return
		end
		s:disable_all()
		p [[Ты закрыла холодильник.]];
	end;
	obj = { 'oil', 'sosiska' };
}
plita = obj {
	nam = _'плита';
	Exam = [[Это электрическая плита, на которой готовят еду. С «того самого» раза ты решила что больше никогда в жизни не подойдешь к этой штуке.]];
	Default = function(s)
		return stead.call(s, 'Exam')
	end;
}
ctol = obj {
	nam = _'стол';
	Exam = [[Небольшой обеденный стол.]];
}

mycat = obj {
	nam = _'кот|~Балбес';
	live = true;
	Exam = [[Он надеется чем-нибудь поживиться.]];
	Take = [[-- Муррр!...]];
	Receive = function(s, w)
		if w == sosiska then
			remove(w, me())
			p [[Ты помахала сосиской перед носом Балбеса и швырнула ее в коридор. Балбес прошмыгнул сквозь открытую дверь.]]
			kot = true;
			move(s, kitchen, here())
		end
	end;
	alias [[Take: Push, Pull, Attack, TalkTo]];
}:disable();

kitchen = room {
	nam = 'Кухня';
	walkout = function(s)
		if up then
			return _'стул';
		end
	end;
	d_to = function(s)
		if up then
			return stul:WalkOut();
		end
	end;
	WalkOut = function(s)
		return stul:WalkOut();
	end;
	dsc = function(s)
		p [[Здесь стоит холодильник, разрисованный тобой и фломастерами, небольшой стол со стульями, за которым все едят или разговаривают о каких-то важных вещах, плита, на которой готовят что-нибудь вкусное и к которой ты решила никогда больше не подходить... после того раза... Но самое главное здесь неприступной горой возвышается к небесам  (точнее к потолку, но для тебя это без разницы) огромный сервант, забитый несметными сокровищами типа конфет, печенья и прочей мелочи, которая сегодня тебя не интересует. Ты пришла взять варенье!]];
		if kot then
			p [[^На кухне тусуется ваш домашний любимец кот  Балабас, надеясь чем-нибудь поживиться.]];
		end
		p [[^Выход в коридор находится на севере.]]
	end;
	n_to = 'koridor';
	exit = function(s, to)
		if up then
			p [[Сначала спустись на пол.]]
			return false
		end
	end;
	left = function(s)
		p [[Ты отправилась обратно в коридор.]]
	end;
	obj = { 'servant', 'icecap', 'stul', 'plita', 'ctol', 'pol'  };
	way = { vroom('коридор', 'koridor') };
}
krovat_rod = obj {
	nam = _'кровать';
	Exam = function(s)
		p [[На огромной кровати спят твои родители. Тебе нужно быть очень осторожной, чтобы добраться до тумбочки и не разбудить их.]];
	end;
	Climb = [[Если ты попытаешься перелезть через спящих родителей, то непременно их разбудишь и варенья тебе тогда точно не видать.]];
	SearchUnder = function(s)
		if not gs or seen 'mycat' then
			mycat:enable();
			p [[Под кроватью ты заметила вашего кота Балбеса, который удивленно смотрит на тебя своими зелеными глазами.]]
			gs = true
		else
			p [[Под кроватью ничего не видно.]]
		end
	end;
	alias [[Climb: Walk]];
}

kluch = obj {
	attr [[takeable]];
	nam = _'~ключ от серванта|ключ';
	Exam = [[Это ключ от серванта!]];
	after_Take = function(s) p [[Ты берешь ключ от серванта.]]; set_music 'mus/key.ogg'; end
}:disable();

box = obj {
	attr [[openable, ~opened, container]];
	nam = _'комод';
	Exam = function(s)
		if not tum then
			p [[Из-за кровати ты не можешь обследовать комод.]]
			return
		end
		p [[Небольшой комод, где мама хранит всякие мелочи. Сейчас он ]];
		if s.opened then
			p [[открыт.]]
		else
			p [[закрыт.]]
		end
		local r, n = parser:content(s, 'вн')
		if n > 0 then
			p ("Внутри комода ты нашла ", r)
		end
	end;
	alias [[ Exam: Search ]];
	when_opened = [[Комод уже открыт.]];
	when_closed = [[Комод уже закрыт.]];
	after_Open = function(s)
		if parser:react() then
			return
		end
		s:enable_all();
		p [[Ты аккуратно открываешь комод.]];
	end;
	after_Close = function(s)
		if parser:react() then
			return
		end
		s:disable_all()
		p [[Ты аккуратно закрываешь комод.]];
	end;
	Default = function(s)
		if not tum then
			p "До него еще надо добраться."
		end
	end;
	Walk = function(s)
		if tum then
			p [[Но ты и так уже у комода.]]
			return
		end
		if not legla then
			p [[Обойти кровать совсем невозможно. Она занимает все пространство от стены до стены.]]
			return
		end
		s:Polz()
	end;
	Polz = function(s)
		if seen 'mycat' then
			p [[Ты боишься, что коту Балбесу это не понравится и он разбудит твоих папу и маму.]]
			return
		end
		if tum then
			p [[Но ты и так уже у комода.]]
			return
		end
		p [[Ты проползла под кроватью и оказалась на другой стороне, возле комода.]]
		tum = true;
	end;
	alias [[ Walk: Climb, WalkIn ]];
	obj = { 'kluch' };
}
bedroom_rod = room {
	nam = 'Спальня родителей';
	dsc = [[Света, проникающего в комнату из приоткрытой двери вполне достаточно, чтобы разглядеть большую кровать, на которой спят твои родители. Она очень большая и едва поместилась в комнате, так что обходить ее сделалось невозможным и маме приходится все время перелазить через папу, чтобы забраться на свое место у стены. Там же у стены стоит небольшой комод, в который, как ты заметила, мама убирает ключ от серванта. Чтобы его добыть тебе надо преодолеть кровать с лежащими на ней мамой и папой.]];
	obj = { 'pol', 'krovat_rod', 'door1', 'box', 'mycat' };
	w_to = 'koridor';
	way = { vroom('коридор', 'koridor') };
	entered = function(s)
		legla = false;
		tum = false;
	end;
	exit = function(s)
		if tum then
			if not legla then
				p [[Сначала нужно добраться до двери.]]
				return false
			end
			s:Polz()
		end
		legla = false
	end;
	walkout = function(s)
		if legla then
			return _'пол';
		end
	end;
	WalkOut = function(s)
		if not legla then
			p [[Ты и так стоишь на ногах.]]
			return
		end
		p [[Ты поднялась на ноги.]]
		legla = false
	end;
	Polz = function(s)
		if not tum then
			box:Walk()
		else
			tum = false
			p [[Ты проползла под кроватью и оказалась возле двери в коридор.]]
		end
	end;
	LieDown = function(s)
		if legla then
			p [[Ты и так лежишь на полу.]]
			return
		end
		p [[Ты легла на пол и обнаружила, что под кроватью достаточно места, чтобы такая маленькая девочка, как ты могла проползти под ней.]]
		krovat_rod:SearchUnder()
		legla = true
		return
	end;
}

parser.events.WalkOut = function(s, w)
end

Verb { function(s)
		if parser:word(2) == 'из' or parser:word(2) == 'с' or parser:word(2) == 'со' or not parser:word(2) then
			return "WalkOut"
		elseif parser:word(2) == 'на' and not isRoom(parser:object()) then
			return "Climb %3"
		else
			if isRoom(parser:object()) then
				return "Walk %3"
			else
				return "WalkIn %3"
			end
		end
	end,
	"встать|~слезть|~спуститься|~вылезти|~выйти", function(s)
	local r = 'в';
	if stend == false or up == true or legla == true then
		r = r .. '|{}';
	end
	r = r .. '|на';
	local w = stead.call(here(), 'walkout')
	if w then
		r = r.. '|из|с|со'
	end
	return r
end, function(s)
	if parser:word() == 'из' or parser:word() == 'с' or parser:word() == 'со' then
		local r,v = stead.call(here(), 'walkout')
		if r then
			return morph:case(r, 'рд')
		else
			return '{}'
		end
	else
		return "{obj}вн|{way}вн"
	end
end};

parser.events.before_Smear = function(self, s, w)
	if not have 'oil' then
		p [[Нужно найти какую-нибудь смазку.]]
		return
	end
	if not w then
		w = oil
	end
	if w ~= oil then
		p [[Это нельзя ни на что намазать.]]
		return
	end
	if w == s then
		p "Масло масляное?"
		return
	end
end

parser.events.after_Smear = function(self, s, w)
	if self:react() then
		return
	end
	if w.smeared then
		local rc = self:gender(w)
		if rc.plural then
			rc = 'ы';
		elseif rc.male then
			rc = '';
		else
			rc = 'а';
		end
		p (self:cap(w:M 'им')..[[ уже смазан]]..rc..[[ маслом, так что наверное больше не нужно.]])
		return
	end
	p ("Ты берёшь немножко масла и намазываешь его на "..w:M('вн')..'.')
	w.smeared = true
	return
end

parser.events.after_LieDown = function(s, w)
	if s:react() then
		return
	end
	p [[Тебе что-то не хочется валяться.]]
end

Verb { function(s)
	if s:word(2) == 'на' and s:object() ~= pol then
		return "Climb %3"
	else
		return "LieDown"
	end
end, "лечь|~упасть", "{}|на", "{obj}вн" }

parser.events.before_Polz = function(s, w)
	if stend and not legla then
		return [[Нельзя ползать стоя.]]
	end
	if not legla then
		return [[Тебе что то не хочется ползать.]]
	end
end

Verb { function(s)
	return "Polz %3"
end, "~ползти", "{}|к", "{obj}дт" };
Verb { "Smear %2 %3", "~смазать", "{obj}вн", "{}|{inv}тв" }
Verb { "Smear %2 %3", "мазать", "{obj}вн", "{}|{inv}тв" }
Verb { "Smear %4 %2", "~намазать", "{inv}вн", "на", "{obj}вн|{inv}вн" }

happyend = cutscene {
	nam = '<c>Конец</c>';
	noparser = true;
	fading = 32;
	hideinv = true;
	entered = function() set_music 'mus/end.ogg' end;
	dsc = [[Ты взяла банку варенья, слезла со стула и, усевшись прямо на полу стала поедать его руками. Здесь и нашли тебя утром родители - спящую, перемазанную вареньем, в обнимку с котом, держащим в зубах недоеденную сосиску, связкой которых ты угостила его в залог того, что после такого подарка он тебя не предаст.^
		Ну, слава Богу, сильно ругать не стали - только отшлепали отцовским ремнем, но что это за цена за целую ночь приключений и сладкой жизни. :)]];
}
